
#include <a5ses/Bitmap.hpp>
#include <a5ses/Display.hpp>
#include <a5ses/Event.hpp>
#include <a5ses/Keyboard.hpp>
#include <a5ses/Timer.hpp>

#include <memory>

using namespace a5;
using namespace std;

int main()
{
	Display display(100, 100, Display::Windowed);

	auto_ptr<Bitmap_Lock> locked(display.Lock(Pixel_Format::Any32NoAlpha));

	int size = locked->Format().ByteSize();
	char *data = reinterpret_cast<char *>(locked->Data());
	
	for (point i = 0; i < 100; ++i)
	{
		for (point j = 0; j < 100; ++j)
		{
			for (point k = 0; k < size; ++k)
			{
				data[int(k + i * size + j * locked->Pitch())] = j * 255 / 99;
			}
		}
	}
	
	delete locked.release();

	display.Flip();
	
	Event_Queue q;
	Keyboard keyboard;
	
	q.Register(keyboard);

	while (true)
	{
		auto_ptr<Event> e(q.Wait());

		auto_ptr<Keyboard::Event> ke(dynamic_cast<Keyboard::Event *>(e.get()));

		if (ke && ke->keycode == Keyboard::Key::Escape)
		{
			break;
		}
	}
	
	return 0;
}
END_OF_MAIN()
